diff --git a/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/RepairableDisplayAdapter.java b/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/RepairableDisplayAdapter.java
new file mode 100644
index 000000000..8d5ed8f0a
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/RepairableDisplayAdapter.java
@@ -0,0 +1,130 @@
+package net.minecraft.client.gui.guidebook.crafting.displays;
+
+import net.minecraft.client.gui.guidebook.GuidebookSlot;
+import net.minecraft.core.data.registry.recipe.RecipeEntryBase;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryRepairable;
+import net.minecraft.core.item.ItemStack;
+
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Random;
+
+public class RepairableDisplayAdapter implements RecipeDisplayAdapter<RecipeEntryRepairable>{
+    @Override
+    public List<GuidebookSlot> getSlots(RecipeEntryRepairable recipe, int recipeAmount, int xOffset, int yOffset) {
+        List<GuidebookSlot> recipeSlots = new ArrayList<>();
+
+        ItemStack[] sharedItemBuffer = new ItemStack[1]; // Cursed shared reference
+        int[] sharedInt = new int[1]; // Another Cursed shared reference
+        RecipeSymbol[] symbols = {new RecipeSymbol(recipe.inItem), recipe.repairMaterial, recipe.repairMaterial, recipe.repairMaterial, new RecipeSymbol(recipe.inItem)};
+
+        for (int i = 0; i < 4; i++) {
+            GuidebookSlot slot;
+            int x = 13 + 18 * (i % 2) + xOffset;
+            int y = 10 + 18 * ((i / 2) + recipeAmount * 3) + yOffset;
+            if (i == 0) {
+                slot = new RepariableGuidebookSlot(i, x, y, symbols[i], false, recipe, sharedItemBuffer);
+            } else {
+                slot = new MaterialGuidebookSlot(i, x, y, symbols[i], false, recipe, sharedInt);
+            }
+            recipeSlots.add(slot);
+        }
+
+        int centerY = (recipeSlots.get(recipeSlots.size()-1).y + recipeSlots.get(recipeSlots.size()-3).y) / 2;
+        recipeSlots.add(new RepairOutputGuidebookSlot(symbols.length - 1, 81 + xOffset, centerY, symbols[4], false,recipe, sharedItemBuffer, sharedInt).setAsOutput());
+        return recipeSlots;
+    }
+
+    public static class RepariableGuidebookSlot extends GuidebookSlot {
+        private final ItemStack[] buffer;
+        private int tickCount = 0;
+        public RepariableGuidebookSlot(int id, int x, int y, RecipeSymbol symbol, boolean discovered, RecipeEntryBase<?, ?, ?> recipe, ItemStack[] itemBuffer) {
+            super(id, x, y, symbol, discovered, recipe);
+            buffer = itemBuffer;
+        }
+
+        @Override
+        public void showRandomItem() {
+            tickCount++;
+            if (tickCount % 3 == 1) {
+                Random r = new Random();
+                if(symbol != null && symbol.getItemGroup() != null){
+                    List<ItemStack> list = symbol.resolve();
+                    ItemStack newItem = list.get(r.nextInt(list.size()));
+                    if (list.size() > 1) {
+                        while (newItem == item){
+                            newItem = list.get(r.nextInt(list.size()));
+                        }
+                    }
+                    item = newItem;
+                }
+                item.setMetadata(r.nextInt(item.getMaxDamage()));
+            }
+            buffer[0] = item;
+        }
+    }
+
+    public static class MaterialGuidebookSlot extends GuidebookSlot {
+        private final int[] buffer;
+        public MaterialGuidebookSlot(int id, int x, int y, RecipeSymbol symbol, boolean discovered, RecipeEntryBase<?, ?, ?> recipe, int[] intBuffer) {
+            super(id, x, y, symbol, discovered, recipe);
+            buffer = intBuffer;
+        }
+
+        @Override
+        public void showRandomItem() {
+            Random r = new Random(System.currentTimeMillis());
+            if (index == 1) buffer[0] = 0; // Reset buffer on first slot
+            if (r.nextInt(3) >= (index)) {
+                item = null;
+                return;
+            }
+            buffer[0]++; // Increment if has a chainlink
+            if(symbol != null && symbol.getItemGroup() != null){
+                List<ItemStack> list = symbol.resolve();
+                ItemStack newItem = list.get(r.nextInt(list.size()));
+                if (list.size() > 1) {
+                    while (newItem == item){
+                        newItem = list.get(r.nextInt(list.size()));
+                    }
+                }
+                item = newItem;
+            } else if (symbol != null) {
+                item = symbol.resolve().get(0);
+            }
+        }
+    }
+
+    public static class RepairOutputGuidebookSlot extends GuidebookSlot {
+        private final ItemStack[] itemBuffer;
+        private final int[] intBuffer;
+        public RepairOutputGuidebookSlot(int id, int x, int y, RecipeSymbol symbol, boolean discovered, RecipeEntryBase<?, ?, ?> recipe, ItemStack[] itemBuffer, int[] intBuffer) {
+            super(id, x, y, symbol, discovered, recipe);
+            this.itemBuffer = itemBuffer;
+            this.intBuffer = intBuffer;
+        }
+
+        @Override
+        public void showRandomItem() {
+            if (itemBuffer[0] == null) {
+                item = null;
+                return;
+            }
+            int chains = intBuffer[0];
+
+            item = new ItemStack(itemBuffer[0]);
+            for (int i = 0; i < chains; i++)
+            {
+                if (item.getMetadata() <= item.getMaxDamage())
+                {
+                    item.setMetadata(item.getMetadata() - item.getMaxDamage() / 8);
+                }
+            }
+            if (item.getMetadata() < 0) {
+                item.setMetadata(0);
+            }
+
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/ScrapDisplayAdapter.java b/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/ScrapDisplayAdapter.java
new file mode 100644
index 000000000..8d5dd04c7
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/ScrapDisplayAdapter.java
@@ -0,0 +1,95 @@
+package net.minecraft.client.gui.guidebook.crafting.displays;
+
+import net.minecraft.client.gui.guidebook.GuidebookSlot;
+import net.minecraft.core.data.registry.recipe.RecipeEntryBase;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryScrap;
+import net.minecraft.core.item.ItemStack;
+
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Random;
+
+public class ScrapDisplayAdapter implements RecipeDisplayAdapter<RecipeEntryScrap>{
+    @Override
+    public List<GuidebookSlot> getSlots(RecipeEntryScrap recipe, int recipeAmount, int xOffset, int yOffset) {
+        List<GuidebookSlot> recipeSlots = new ArrayList<>();
+
+        ItemStack[] sharedItemBuffer = new ItemStack[1]; // Cursed shared reference
+        RecipeSymbol[] symbols = {new RecipeSymbol(recipe.itemToScrap.getDefaultStack()), null, null, null, new RecipeSymbol(recipe.scrapYieldStack)};
+
+        for (int i = 0; i < 4; i++) {
+            GuidebookSlot slot;
+            int x = 13 + 18 * (i % 2) + xOffset;
+            int y = 10 + 18 * ((i / 2) + recipeAmount * 3) + yOffset;
+            if (i == 0) {
+                slot = new ToScrapGuidebookSlot(i, x, y, symbols[i], false, recipe, sharedItemBuffer);
+            } else {
+                slot = new GuidebookSlot(i, x, y, symbols[i], false, recipe);
+            }
+            recipeSlots.add(slot);
+        }
+
+        int centerY = (recipeSlots.get(recipeSlots.size()-1).y + recipeSlots.get(recipeSlots.size()-3).y) / 2;
+        recipeSlots.add(new ScrapYieldGuidebookSlot(symbols.length - 1, 81 + xOffset, centerY, symbols[4], false,recipe, sharedItemBuffer).setAsOutput());
+        return recipeSlots;
+    }
+
+    public static class ToScrapGuidebookSlot extends GuidebookSlot {
+        private final ItemStack[] itemBuffer;
+        public ToScrapGuidebookSlot(int id, int x, int y, RecipeSymbol symbol, boolean discovered, RecipeEntryBase<?, ?, ?> recipe, ItemStack[] itemBuffer) {
+            super(id, x, y, symbol, discovered, recipe);
+            this.itemBuffer = itemBuffer;
+        }
+
+        @Override
+        public void showRandomItem() {
+            Random r = new Random();
+            if(symbol != null && symbol.getItemGroup() != null){
+                List<ItemStack> list = symbol.resolve();
+                ItemStack newItem = list.get(r.nextInt(list.size()));
+                if (list.size() > 1) {
+                    while (newItem == item){
+                        newItem = list.get(r.nextInt(list.size()));
+                    }
+                }
+                item = newItem;
+            }
+            item.setMetadata(r.nextInt(item.getMaxDamage()));
+            itemBuffer[0] = item;
+        }
+    }
+
+    public static class ScrapYieldGuidebookSlot extends GuidebookSlot {
+        private final ItemStack[] itemBuffer;
+        private final RecipeEntryScrap recipe;
+        public ScrapYieldGuidebookSlot(int id, int x, int y, RecipeSymbol symbol, boolean discovered, RecipeEntryScrap recipe, ItemStack[] itemBuffer) {
+            super(id, x, y, symbol, discovered, recipe);
+            this.itemBuffer = itemBuffer;
+            this.recipe = recipe;
+        }
+
+        @Override
+        public void showRandomItem() {
+            if (itemBuffer[0] == null) {
+                item = null;
+                return;
+            } else {
+                item = recipe.scrapYield.getDefaultStack();
+            }
+            Random r = new Random();
+            if(symbol != null && symbol.getItemGroup() != null){
+                List<ItemStack> list = symbol.resolve();
+                ItemStack newItem = list.get(r.nextInt(list.size()));
+                if (list.size() > 1) {
+                    while (newItem == item){
+                        newItem = list.get(r.nextInt(list.size()));
+                    }
+                }
+                item = newItem;
+            }
+            item.stackSize = (int) (((float)(itemBuffer[0].getMaxDamage() - (itemBuffer[0].getMetadata())) / itemBuffer[0].getMaxDamage()) * (recipe.maxYield - 1)) + 1;
+            if (item.stackSize <= 0) item = null;
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/ShapedDisplayAdapter.java b/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/ShapedDisplayAdapter.java
new file mode 100644
index 000000000..251c82a57
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/ShapedDisplayAdapter.java
@@ -0,0 +1,65 @@
+package net.minecraft.client.gui.guidebook.crafting.displays;
+
+import net.minecraft.client.gui.guidebook.GuidebookSlot;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingShaped;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class ShapedDisplayAdapter implements RecipeDisplayAdapter<RecipeEntryCraftingShaped> {
+    @Override
+    public List<GuidebookSlot> getSlots(RecipeEntryCraftingShaped recipe, int recipeAmount, int xOffset, int yOffset) {
+        List<GuidebookSlot> recipeSlots = new ArrayList<>();
+        int slotsAmount;
+
+        if (recipe.recipeHeight > 2 || recipe.recipeWidth > 2)
+        {
+            slotsAmount = 10;
+
+            for (int i = 0; i < slotsAmount - 1; i++)
+            {
+                final int slotX = i % 3;
+                final int slotY = i / 3;
+
+                if (slotX >= recipe.recipeWidth || slotY >= recipe.recipeHeight)
+                {
+                    recipeSlots.add(new GuidebookSlot(i, 1 + 18 * (i % 3) + xOffset, 1 + 18 * ((i / 3)+recipeAmount*3) + yOffset, null, false,recipe));
+                }
+                else
+                {
+                    RecipeSymbol stack = recipe.getInput()[slotX + (slotY * recipe.recipeWidth)];
+                    recipeSlots.add(new GuidebookSlot(i, 1 + 18 * (i % 3) + xOffset, 1 + 18 * ((i / 3)+recipeAmount*3) + yOffset, stack, false,recipe));
+                }
+            }
+
+            int centerY = (recipeSlots.get(recipeSlots.size()-1).y + recipeSlots.get(recipeSlots.size()-8).y) / 2;
+            recipeSlots.add(new GuidebookSlot(slotsAmount - 1, 81 + xOffset, centerY, new RecipeSymbol(recipe.getOutput().copy()), false,recipe).setAsOutput());
+        }
+        else
+        {
+            slotsAmount = 5;
+
+
+            for (int i = 0; i < slotsAmount - 1; i++)
+            {
+                final int slotX = i % 2;
+                final int slotY = i / 2;
+
+                if (slotX >= recipe.recipeWidth || slotY >= recipe.recipeHeight)
+                {
+                    recipeSlots.add(new GuidebookSlot(i, 13 + 18 * (i % 2) + xOffset, 10 + 18 * ((i / 2)+recipeAmount*3) + yOffset, null, false,recipe));
+                }
+                else
+                {
+                    RecipeSymbol stack = recipe.getInput()[slotX + (slotY * recipe.recipeWidth)];
+                    recipeSlots.add(new GuidebookSlot(i, 13 + 18 * (i % 2) + xOffset, 10 + 18 * ((i / 2)+recipeAmount*3) + yOffset, stack, false,recipe));
+                }
+            }
+
+            int centerY = (recipeSlots.get(recipeSlots.size()-1).y + recipeSlots.get(recipeSlots.size()-3).y) / 2;
+            recipeSlots.add(new GuidebookSlot(slotsAmount - 1, 81 + xOffset, centerY, new RecipeSymbol(recipe.getOutput()), false,recipe).setAsOutput());
+        }
+        return recipeSlots;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/ShapelessDisplayAdapter.java b/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/ShapelessDisplayAdapter.java
new file mode 100644
index 000000000..b87b71c28
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/ShapelessDisplayAdapter.java
@@ -0,0 +1,53 @@
+package net.minecraft.client.gui.guidebook.crafting.displays;
+
+import net.minecraft.client.gui.guidebook.GuidebookSlot;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingShapeless;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class ShapelessDisplayAdapter implements RecipeDisplayAdapter<RecipeEntryCraftingShapeless>{
+    @Override
+    public List<GuidebookSlot> getSlots(RecipeEntryCraftingShapeless recipe, int recipeAmount, int xOffset, int yOffset) {
+        List<GuidebookSlot> recipeSlots = new ArrayList<>();
+        int slotsAmount;
+
+        if (recipe.getInput().size() > 4)
+        {
+            slotsAmount = 10;
+
+
+            for (int i = 0; i < Math.max(recipe.getInput().size(),9); i++)
+            {
+                if(i >= recipe.getInput().size()){
+                    recipeSlots.add(new GuidebookSlot(i, 1 + 18 * (i % 3) + xOffset, 1 + 18 * ((i / 3)+recipeAmount*3) + yOffset, null, false,recipe));
+                    continue;
+                }
+                RecipeSymbol stack = recipe.getInput().get(i);
+                recipeSlots.add(new GuidebookSlot(i, 1 + 18 * (i % 3) + xOffset, 1 + 18 * ((i / 3)+recipeAmount*3) + yOffset, stack, false,recipe));
+            }
+
+            int centerY = (recipeSlots.get(recipeSlots.size()-1).y + recipeSlots.get(recipeSlots.size()-8).y) / 2;
+            recipeSlots.add(new GuidebookSlot(slotsAmount - 1, 81 + xOffset, centerY, new RecipeSymbol(recipe.getOutput()), false,recipe).setAsOutput());
+        }
+        else
+        {
+            slotsAmount = 5;
+
+            for (int i = 0; i < Math.max(recipe.getInput().size(),4); i++)
+            {
+                if(i >= recipe.getInput().size()){
+                    recipeSlots.add(new GuidebookSlot(i, 13 + 18 * (i % 2) + xOffset, 10 + 18 * ((i / 2)+recipeAmount*3) + yOffset, null, false,recipe));
+                    continue;
+                }
+                RecipeSymbol stack = recipe.getInput().get(i);
+                recipeSlots.add(new GuidebookSlot(i, 13 + 18 * (i % 2) + xOffset, 10 + 18 * ((i / 2)+recipeAmount*3) + yOffset, stack, false,recipe));
+            }
+
+            int centerY = (recipeSlots.get(recipeSlots.size()-1).y + recipeSlots.get(recipeSlots.size()-3).y) / 2;
+            recipeSlots.add(new GuidebookSlot(slotsAmount - 1, 81 + xOffset, centerY, new RecipeSymbol(recipe.getOutput()), false,recipe).setAsOutput());
+        }
+        return recipeSlots;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/ToolDisplayAdapter.java b/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/ToolDisplayAdapter.java
new file mode 100644
index 000000000..a52b1bf75
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/ToolDisplayAdapter.java
@@ -0,0 +1,59 @@
+package net.minecraft.client.gui.guidebook.crafting.displays;
+
+import net.minecraft.client.gui.guidebook.GuidebookSlot;
+import net.minecraft.core.data.registry.recipe.RecipeEntryBase;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingWithTool;
+import net.minecraft.core.item.ItemStack;
+
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Random;
+
+public class ToolDisplayAdapter implements RecipeDisplayAdapter<RecipeEntryCraftingWithTool>{
+    @Override
+    public List<GuidebookSlot> getSlots(RecipeEntryCraftingWithTool recipe, int recipeAmount, int xOffset, int yOffset) {
+        List<GuidebookSlot> recipeSlots = new ArrayList<>();
+
+        RecipeSymbol[] symbols = {recipe.inputSymbol, recipe.toolToUse, null, null, new RecipeSymbol(recipe.output)};
+
+        for (int i = 0; i < 4; i++) {
+            GuidebookSlot slot;
+            int x = 13 + 18 * (i % 2) + xOffset;
+            int y = 10 + 18 * ((i / 2) + recipeAmount * 3) + yOffset;
+            if (symbols[i] == recipe.toolToUse) {
+                slot = new ToolGuidebookSlot(i, x, y, symbols[i], false, recipe);
+            } else {
+                slot = new GuidebookSlot(i, x, y, symbols[i], false, recipe);
+            }
+            recipeSlots.add(slot);
+        }
+
+        int centerY = (recipeSlots.get(recipeSlots.size()-1).y + recipeSlots.get(recipeSlots.size()-3).y) / 2;
+        recipeSlots.add(new GuidebookSlot(symbols.length - 1, 81 + xOffset, centerY, symbols[4], false,recipe).setAsOutput());
+        return recipeSlots;
+    }
+
+    public static class ToolGuidebookSlot extends GuidebookSlot {
+
+        public ToolGuidebookSlot(int id, int x, int y, RecipeSymbol symbol, boolean discovered, RecipeEntryBase<?, ?, ?> recipe) {
+            super(id, x, y, symbol, discovered, recipe);
+        }
+
+        @Override
+        public void showRandomItem() {
+            Random r = new Random();
+            if(symbol != null && symbol.getItemGroup() != null){
+                List<ItemStack> list = symbol.resolve();
+                ItemStack newItem = list.get(r.nextInt(list.size()));
+                if (list.size() > 1) {
+                    while (newItem == item){
+                        newItem = list.get(r.nextInt(list.size()));
+                    }
+                }
+                item = newItem;
+            }
+            item.setMetadata(r.nextInt(item.getMaxDamage()));
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/UndyeDisplayAdapter.java b/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/UndyeDisplayAdapter.java
new file mode 100644
index 000000000..bc8b8a0dd
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/UndyeDisplayAdapter.java
@@ -0,0 +1,33 @@
+package net.minecraft.client.gui.guidebook.crafting.displays;
+
+import net.minecraft.client.gui.guidebook.GuidebookSlot;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryUndyeing;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class UndyeDisplayAdapter implements RecipeDisplayAdapter<RecipeEntryUndyeing>{
+    @Override
+    public List<GuidebookSlot> getSlots(RecipeEntryUndyeing recipe, int recipeAmount, int xOffset, int yOffset) {
+        List<GuidebookSlot> recipeSlots = new ArrayList<>();
+
+        int slotsAmount = 10;
+        for (int i = 0; i < slotsAmount - 1; i++)
+        {
+            if (i == 4) {
+                recipeSlots.add(new GuidebookSlot(i, 1 + 18 * (i % 3) + xOffset, 1 + 18 * ((i / 3)+recipeAmount*3) + yOffset, new RecipeSymbol(Blocks.SPONGE_WET.getDefaultStack()), false,recipe));
+            } else {
+                RecipeSymbol stack = recipe.inputSymbol;
+                recipeSlots.add(new GuidebookSlot(i, 1 + 18 * (i % 3) + xOffset, 1 + 18 * ((i / 3)+recipeAmount*3) + yOffset, stack, false,recipe));
+            }
+        }
+
+        int centerY = (recipeSlots.get(recipeSlots.size()-1).y + recipeSlots.get(recipeSlots.size()-8).y) / 2;
+        recipeSlots.add(new GuidebookSlot(slotsAmount - 1, 81 + xOffset, centerY, new RecipeSymbol(recipe.output.copy()), false,recipe).setAsOutput());
+
+
+        return recipeSlots;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/entity/NoteBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/NoteBlockEntity.java
index e221f94e3..cbe8141d8 100644
--- a/src/main/java/net/minecraft/core/block/entity/NoteBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/NoteBlockEntity.java
@@ -53,24 +53,24 @@ public class NoteBlockEntity extends BlockEntity
             return;
         }
         Material material = world.getBlockMaterial(x, y - 1, z);
-        byte byte0 = 0;
+        byte noteIndex = 0;
         if(material == Material.stone)
         {
-            byte0 = 1;
+            noteIndex = 1;
         }
         if(material == Material.sand)
         {
-            byte0 = 2;
+            noteIndex = 2;
         }
         if(material == Material.glass)
         {
-            byte0 = 3;
+            noteIndex = 3;
         }
         if(material == Material.wood)
         {
-            byte0 = 4;
+            noteIndex = 4;
         }
-        world.triggerEvent(x, y, z, byte0, note);
+        world.triggerEvent(x, y, z, noteIndex, note);
     }
 
     public byte note;
diff --git a/src/main/java/net/minecraft/core/block/piston/BasePistonBlock.java b/src/main/java/net/minecraft/core/block/piston/BasePistonBlock.java
index 42e14c874..31edea354 100644
--- a/src/main/java/net/minecraft/core/block/piston/BasePistonBlock.java
+++ b/src/main/java/net/minecraft/core/block/piston/BasePistonBlock.java
@@ -105,7 +105,8 @@ public class BasePistonBlock extends Block
         if(world.getSignal(x, y, z, Side.BOTTOM)) {
             return true;
         }
-        if(world.getSignal(x, y + 2, z, Side.TOP)) {
+        // QC
+        if(direction != 1 && world.getSignal(x, y + 2, z, Side.TOP)) {
             return true;
         }
         if(world.getSignal(x, y + 1, z - 1, Side.NORTH)) {
@@ -123,6 +124,7 @@ public class BasePistonBlock extends Block
     @Override
     public void triggerEvent(World world, int x, int y, int z, int index, int data)
     {
+        // Index 0 is pushing, index 1 is retracting
         int direction = data;
         if (direction >= 6) direction = 0;
         if(index == 0)
@@ -138,10 +140,15 @@ public class BasePistonBlock extends Block
             BlockEntity tileentity = world.getBlockEntity(x + PistonDirections.xOffset[direction], y + PistonDirections.yOffset[direction], z + PistonDirections.zOffset[direction]);
             if(tileentity != null && (tileentity instanceof MovingPistonBlockEntity))
             {
-                ((MovingPistonBlockEntity)tileentity).finalTick();
+                MovingPistonBlockEntity moving = ((MovingPistonBlockEntity) tileentity);
+                if (!moving.isExtending()) {
+                    ((MovingPistonBlockEntity)tileentity).finalTick();
+                } else {
+                    world.setBlock(x + PistonDirections.xOffset[direction], y + PistonDirections.yOffset[direction], z + PistonDirections.zOffset[direction], 0);
+                }
             }
             world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id, direction);
-            world.setBlockTileEntity(x, y, z, MovingPistonBlock.createTileEntity(id, direction, direction, false, true));
+            world.replaceBlockTileEntity(x, y, z, MovingPistonBlock.createTileEntity(id, direction, direction, false, true));
             if(isSticky)
             {
                 int x1 = x + PistonDirections.xOffset[direction] * 2;
@@ -167,12 +174,13 @@ public class BasePistonBlock extends Block
                 }
                 if(!flag && id1 > 0 && isPushable(id1, world, x1, y1, z1, false) && (Block.blocksList[id1].getPistonPushReaction() == 0 || id1 == Blocks.PISTON_BASE.id || id1 == Blocks.PISTON_BASE_STICKY.id))
                 {
-                    world.setBlockWithNotify(x1, y1, z1, 0);
+                    world.setBlock(x1, y1, z1, 0);
                     x += PistonDirections.xOffset[direction];
                     y += PistonDirections.yOffset[direction];
                     z += PistonDirections.zOffset[direction];
                     world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id, meta1);
-                    world.setBlockTileEntity(x, y, z, MovingPistonBlock.createTileEntity(id1, meta1, direction, false, false));
+                    world.replaceBlockTileEntity(x, y, z, MovingPistonBlock.createTileEntity(id1, meta1, direction, false, false));
+                    world.notifyBlockChange(x1, y1, z1, 0);
                 } else
                 if(!flag)
                 {
@@ -288,7 +296,7 @@ public class BasePistonBlock extends Block
             {
                 break;
             }
-            if(yo <= 0 || yo >= world.getHeightBlocks() - 1)
+            if(yo < 0 || yo >= world.getHeightBlocks())
             {
                 return false;
             }
@@ -328,9 +336,9 @@ public class BasePistonBlock extends Block
 
     private boolean tryExtend(World world, int x, int y, int z, int direction)
     {
-        int i1 = x + PistonDirections.xOffset[direction % 6];
-        int j1 = y + PistonDirections.yOffset[direction % 6];
-        int k1 = z + PistonDirections.zOffset[direction % 6];
+        int xo = x + PistonDirections.xOffset[direction % 6];
+        int yo = y + PistonDirections.yOffset[direction % 6];
+        int zo = z + PistonDirections.zOffset[direction % 6];
         int l1 = 0;
         do
         {
@@ -338,53 +346,66 @@ public class BasePistonBlock extends Block
             {
                 break;
             }
-            if(j1 <= 0 || j1 >= world.getHeightBlocks() - 1)
+            if(yo < 0 || yo >= world.getHeightBlocks())
             {
                 return false;
             }
-            int j2 = world.getBlockId(i1, j1, k1);
+            int j2 = world.getBlockId(xo, yo, zo);
             if(j2 == 0)
             {
                 break;
             }
-            if(!isPushable(j2, world, i1, j1, k1, true))
+            if(!isPushable(j2, world, xo, yo, zo, true))
             {
                 return false;
             }
             if(Block.blocksList[j2].getPistonPushReaction() == 1)
             {
-                Block.blocksList[j2].dropBlockWithCause(world, EnumDropCause.WORLD, i1, j1, k1, world.getBlockMetadata(i1, j1, k1), null, null);
-                world.setBlockWithNotify(i1, j1, k1, 0);
+                Block.blocksList[j2].dropBlockWithCause(world, EnumDropCause.WORLD, xo, yo, zo, world.getBlockMetadata(xo, yo, zo), null, null);
+                world.setBlockWithNotify(xo, yo, zo, 0);
                 break;
             }
             if(l1 == 12)
             {
                 return false;
             }
-            i1 += PistonDirections.xOffset[direction % 6];
-            j1 += PistonDirections.yOffset[direction % 6];
-            k1 += PistonDirections.zOffset[direction % 6];
+            xo += PistonDirections.xOffset[direction % 6];
+            yo += PistonDirections.yOffset[direction % 6];
+            zo += PistonDirections.zOffset[direction % 6];
             l1++;
         } while(true);
         int l2 = 0;
-        for(; i1 != x || j1 != y || k1 != z; k1 = l2)
+        for(; xo != x || yo != y || zo != z; zo = l2)
         {
-            int i2 = i1 - PistonDirections.xOffset[direction % 6];
-            int k2 = j1 - PistonDirections.yOffset[direction % 6];
-            l2 = k1 - PistonDirections.zOffset[direction % 6];
+            int i2 = xo - PistonDirections.xOffset[direction % 6];
+            int k2 = yo - PistonDirections.yOffset[direction % 6];
+            l2 = zo - PistonDirections.zOffset[direction % 6];
             int i3 = world.getBlockId(i2, k2, l2);
             int j3 = world.getBlockMetadata(i2, k2, l2);
             if(i3 == id && i2 == x && k2 == y && l2 == z)
             {
-                world.setBlockAndMetadata(i1, j1, k1, Blocks.PISTON_MOVING.id, direction | (isSticky ? 8 : 0));
-                world.setBlockTileEntity(i1, j1, k1, MovingPistonBlock.createTileEntity(Blocks.PISTON_HEAD.id, direction | (isSticky ? 8 : 0), direction, true, false));
+                world.setBlockAndMetadata(xo, yo, zo, Blocks.PISTON_MOVING.id, direction | (isSticky ? 8 : 0));
+                world.replaceBlockTileEntity(xo, yo, zo, MovingPistonBlock.createTileEntity(Blocks.PISTON_HEAD.id, direction | (isSticky ? 8 : 0), direction, true, false));
+            } else if (i3 == Blocks.PISTON_MOVING.id)
+            {
+                BlockEntity old = world.getBlockEntity(i2, k2, l2);
+                if (old instanceof MovingPistonBlockEntity) {
+                    MovingPistonBlockEntity moving = (MovingPistonBlockEntity) old;
+                    if (!moving.isSourcePiston()) {
+                        i3 = moving.getMovedId();
+                        j3 = moving.getMovedData();
+                        world.removeBlockTileEntity(i2, k2, l2);
+                    }
+                }
+                world.setBlockAndMetadata(xo, yo, zo, Blocks.PISTON_MOVING.id, j3);
+                world.replaceBlockTileEntity(xo, yo, zo, MovingPistonBlock.createTileEntity(i3, j3, direction, true, false));
             } else
             {
-                world.setBlockAndMetadata(i1, j1, k1, Blocks.PISTON_MOVING.id, j3);
-                world.setBlockTileEntity(i1, j1, k1, MovingPistonBlock.createTileEntity(i3, j3, direction, true, false));
+                world.setBlockAndMetadata(xo, yo, zo, Blocks.PISTON_MOVING.id, j3);
+                world.replaceBlockTileEntity(xo, yo, zo, MovingPistonBlock.createTileEntity(i3, j3, direction, true, false));
             }
-            i1 = i2;
-            j1 = k2;
+            xo = i2;
+            yo = k2;
         }
 
         return true;
